/*
 * The Simple Media API RA
 *
 * The source code contained in this file is in in the public domain.
 * It can be used in any project or product without prior permission,
 * license or royalty payments. There is  NO WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR STATUTORY, INCLUDING, WITHOUT LIMITATION,
 * THE IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 * AND DATA ACCURACY.  We do not warrant or make any representations
 * regarding the use of the software or the  results thereof, including
 * but not limited to the correctness, accuracy, reliability or
 * usefulness of the software.
 */

package org.mobicents.slee.resource.media.ra;

import org.mobicents.slee.resource.media.ratype.MediaContext;

/**
 * A super class for all implementations of media contexts.
 *
 * @author Oleg Kulikov
 */
public abstract class BaseMediaContext implements MediaContext {
    
    /** identifier of the media context */
    private String id = Long.toString(System.currentTimeMillis());
    
    /** Creates a new instance of BaseContext */
    public BaseMediaContext() {
    }

    /** 
     * (Non Java-doc).
     *
     * @see org.mobicents.slee.resource.media.ratype.MediaContext#getId().
     */
    public String getId() {
        return id;
    }
}    
